routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/',[\App\Http\Controllers\CategoryController::class, 'index'])->name('house');

Route::resource('category', \App\Http\Controllers\CategoryController::class)->only('index', 'show');
Route::resource('paper', \App\Http\Controllers\PaperController::class);
Route::post('paper.{paper}', [\App\Http\Controllers\PaperController::class, 'rating'])->name('rating-paper');
Route::resource('comment', \App\Http\Controllers\CommentController::class);
Route::resource('account', \App\Http\Controllers\AccountController::class)->only('show');
Route::resource('papers.comments', \App\Http\Controllers\PapersCommentsController::class)->only('store');


Auth::routes();
Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

app/Models/Paper.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Paper extends Model
{
    use HasFactory;
    protected $fillable = [
        'title',
        'content',
        'publish_date',
        'user_id',
        'category_id',
        'tag_id',
    ];

    public function category()
    {
        return $this->belongsTo(Category::class);
    }
    public function user()
    {
        return $this->belongsTo(User::class);
    }
    public function tag()
    {
        return $this->belongsTo(Tag::class);
    }
    public function comments()
    {
        return $this->hasMany(Comment::class);
    }
}

app/Http/Controllers/PaperController.php
<?php

namespace App\Http\Controllers;

use App\Models\Category;
use App\Models\Comment;
use App\Models\Paper;
use App\Models\Rating;
use App\Models\Tag;
use Illuminate\Http\Request;

class PaperController extends Controller
{

    public function index()
    {
        $this->authorize('create-paper', auth()->user());
        $categories = Category::all();
        $tags = Tag::all();
        return view('client.paper.index', compact('categories', 'tags' ));
    }
    public function store(Request $request)
    {
        $this->authorize('create-paper', auth()->user());
       $validated = $request->validate([
           'title' => ['min:3', 'required', 'max:255'],
           'content' => ['min:3', 'required', 'max:2048'],
           'publish_date' => [ 'nullable'],
           'category_id' => [ 'max:255'],
           'tag_id' => [ 'max:255'],
           'user_id' => [ 'max:255'],
       ]);
       $paper = new Paper($validated);
       $paper->save();

        return redirect()->route('category.index')->with('success', 'Успешно создан');
    }

    public function show(Paper $paper)
    {
        $comments = Paper::find($paper->id)->comments->where('approve', '1');
        return view('client.paper.show', compact('paper','comments' ));
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Paper $paper)
    {
        $categories = Category::all();
        $tags = Tag::all();
        return view('client.paper.edit', compact('paper','categories', 'tags' ));

    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Paper $paper)
    {
        $this->authorize('create-paper', auth()->user());

        $validated = $request->validate([
            'title' => ['min:3', 'required', 'max:255'],
            'content' => ['min:3', 'required', 'max:2048'],
            'publish_date' => [ 'nullable'],
            'category_id' => [ 'max:255'],
            'tag_id' => [ 'max:255'],
            'user_id' => [ 'max:255'],
        ]);
        $paper->update($validated);


        return redirect()->route('category.index')->with('success', 'Успешно изменен');

    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Paper $paper)
    {
        $this->authorize('create-date', auth()->user());
        $paper->delete();
        return redirect()->route('category.index')->with('success', 'Успешно удален');
    }

    public function rating(Request $request ,Paper $paper)
    {
        $this->authorize('create-paper', auth()->user());
        $validated = $request->validate([
            'quality'=> ['int', 'nullable'],
            'relevance'=> ['int', 'nullable'],
            'satisfaction'=> ['int', 'nullable'],
        ]);
        $validated['user_id'] = $paper->user_id;
        $validated['paper_id'] = $paper->id;
        Rating::create($validated);
        return redirect()->back()->with('success', 'оценена');
    }

}

resources/views/client/paper/edit.blade.php
@extends('layouts.app')
@section('content')

    <h5>Создать </h5>
    <form action="{{route('paper.update',['paper'=> $paper])}}" method="POST">
        @csrf
        @method('PUT')
        <div class="form-group">
            <input type="hidden" name="user_id" value="{{auth()->user()->id}}">
        </div>
        <div class="form-group">
            <div class="mb-3">
                <label for="exampleInputPassword1" class="form-label">Title</label>
                <input name="title" value="{{$paper->title}}" type="text" class="form-control" id="exampleInputPassword1">
            </div>
            <div class="mb-3">
                <label for="exampleInputPassword2" class="form-label">Content</label>
                <input name="content" value="{{$paper->content}}" type="text" class="form-control" id="exampleInputPassword2">
            </div>

            @if(Auth::user()->is_admin)
                <div class="mb-3">
                    <label for="exampleInputPassword2" class="form-label">Дата публикации</label>
                    <input type="date" name="publish_date" value="{{$paper->publish_date}}"  class="form-control" id="exampleInputPassword2">
                </div>
            @endif

            <div class="form-group">
                <label class="my-1 mr-2" for="inlineFormCustomSelectPref"> category</label>
                <select class="custom-select my-1 mr-sm-2" name="category_id" id="inlineFormCustomSelectPref">
                    @foreach($categories as $category)
                        <option value="{{$category->id}}">{{$category->name}}</option>
                    @endforeach
                </select>
            </div>

            <div class="form-group">
                <label class="my-1 mr-2" for="inlineFormCustomSelectPref"> Tags</label>
                <select class="custom-select my-1 mr-sm-2" name="tag_id" id="inlineFormCustomSelectPref">
                    @foreach($tags as $tag)
                        <option value="{{$tag->id}}">{{$tag->name}}</option>
                    @endforeach
                </select>
            </div>

        </div>
        <button class=" btn btn-success" type="submit">Загрузить</button>
    </form>
@endsection

resources/views/client/paper/index.blade.php
@extends('layouts.app')
@section('content')

    <h5>Создать </h5>
    <form action="{{route('paper.store')}}" method="POST">
        @csrf

        <div class="form-group">
            <input type="hidden" name="user_id" value="{{auth()->user()->id}}">
        </div>
        <div class="form-group">
            <div class="mb-3">
                <label for="exampleInputPassword1" class="form-label">Title</label>
                <input name="title" type="text" class="form-control" id="exampleInputPassword1">
            </div>
            <div class="mb-3">
                <label for="exampleInputPassword2" class="form-label">Content</label>
                <input name="content" type="text" class="form-control" id="exampleInputPassword2">
            </div>

     @if(Auth::user()->is_admin)
    <div class="mb-3">
        <label for="exampleInputPassword2" class="form-label">Дата публикации</label>
        <input type="date" name="publish_date"  class="form-control" id="exampleInputPassword2">
    </div>
     @endif

    <div class="form-group">
        <label class="my-1 mr-2" for="inlineFormCustomSelectPref"> category</label>
        <select class="custom-select my-1 mr-sm-2" name="category_id" id="inlineFormCustomSelectPref">
            @foreach($categories as $category)
                <option value="{{$category->id}}">{{$category->name}}</option>
            @endforeach
        </select>
    </div>

    <div class="form-group">
        <label class="my-1 mr-2" for="inlineFormCustomSelectPref"> Tags</label>
        <select class="custom-select my-1 mr-sm-2" name="tag_id" id="inlineFormCustomSelectPref">
            @foreach($tags as $tag)
                <option value="{{$tag->id}}">{{$tag->name}}</option>
            @endforeach
        </select>
    </div>

</div>
<button class=" btn btn-success" type="submit">Загрузить</button>
</form>
@endsection

resources/views/client/paper/show.blade.php
@extends('layouts.app')
@section('content')
    @can('create-paper', Auth::user())
        <a class="btn btn-success m-2" href="{{route('paper.index')}}">Создать новость</a>
    @endcan
    <div class="row">
        <div class="col-6 border p-2">
            <h2>{{$paper->title}}</h2>
            <p>{{$paper->content}}</p>
            <p>дата публикации: {{$paper->publish_date}}</p>
            <p>дата создание: {{$paper->created_at}}</p>
            <p>автор: {{$paper->user->name}}</p>
            @can('create-date', auth()->user())
            <form action="{{route('paper.destroy',['paper' => $paper])}}" method="post">
                @csrf
                @method('DELETE')
                <button class="btn btn-danger" type="submit">delete</button>
            </form>
                <a href="{{route('paper.edit', ['paper'=>$paper])}}" class="btn btn-warning">edit</a>
            @endcan

            @can('create-paper', Auth::user())
                <div class="col-6">
                    <form action="{{route('rating-paper',['paper'=>$paper])}}" method="post">
                        @csrf
                        <div class="mb-3">
                            <label for="exampleInputPassword1" class="form-label">quality</label>
                            <input name="quality" type="text" class="form-control" id="exampleInputPassword1">
                        </div>
                        <div class="mb-3">
                            <label for="exampleInputPassword1" class="form-label">relevance</label>
                            <input name="relevance" type="text" class="form-control" id="exampleInputPassword1">
                        </div>
                        <div class="mb-3">
                            <label for="exampleInputPassword1" class="form-label">satisfaction</label>
                            <input name="satisfaction" type="text" class="form-control" id="exampleInputPassword1">
                        </div>
                        <button class="btn btn-warning" type="submit" >оценить</button>
                    </form>
                </div>
            @endcan
        </div>

        <div class="col-4">
            @auth()
                <form action="{{route('papers.comments.store', ['paper' => $paper])}}" method="post">
                    @csrf
                    <input name="comment" class="comments-input" type="text" placeholder="Добавить комментарии..."/>
                    <input type="hidden" name="user_id" value="{{auth()->user()->id}}">
                    <input type="hidden" name="post_user_id" value="{{$paper->user_id}}">

                    <button type="submit" class="btn btn-info">добавить</button>

                </form>
            @endauth
            <h6><b>Коментарии</b>:</h6>
            @foreach($comments as $comment)
                <p><i>{{$comment->user->name}}</i></p>
                <p>{{$comment->comment}}</p>
                <br>
            @endforeach

        </div>
        </div>




@endsection